import {
  GameSchema,
  GamepinSchema,
  User_GameSchema,
} from "../prisma/generated/zod"
import { z } from "zod"

export const PlayerSchema = z
  .object({
    email: z.string().nullable(),
    name: z.string().nullable(),
  })
  .and(User_GameSchema)

export const CreateSchema = z
  .object({
    game: GameSchema.nullish(),
    gamePin: GamepinSchema.nullish(),
    player1: PlayerSchema.nullish(),
    player2: PlayerSchema.nullish(),
  })
  .strict()

export const GamePropsSchema = z.object({
  payload: CreateSchema.nullable(),
  hash: z.string().nullable(),
})

export type GamePropsSchema = z.infer<typeof GamePropsSchema>
