import type {
  NextApiResponseWithSocket,
  cServer,
} from "../../interfaces/NextApiSocket"
import type { NextApiRequest } from "next"
import { Server } from "socket.io"

const SocketHandler = (req: NextApiRequest, res: NextApiResponseWithSocket) => {
  if (res.socket.server.io) {
    console.log("Socket is already running " + req.url)
  } else {
    console.log("Socket is initializing " + req.url)
    const io: cServer = new Server(res.socket.server, {
      path: "/api/ws",
    })
    res.socket.server.io = io

    // io.use(authenticate)
    io.on("connection", (socket) => {
      socket.on("input-change", (msg) => {
        if (!socket.data.user) socket.emit("unauthenticated")
        // socket.broadcast.emit("update-input", msg)
        io.emit("update-input", msg)
      })

      socket.on("test", (payload) => {
        console.log("Got test:", payload)
        // ...
      })

      socket.emit("test2", "lol")
    })
  }
  res.end()
}

export default SocketHandler
